Subject: Re: [PATCH] TCP_FAILFAST: a new socket option to timeout/abort a connection quicker

From: Hagen Paul Pfeifer <[email-masked]>
Date: Wed, 25 Aug 2010 10:21:39 +0200

On Tue, 24 Aug 2010 15:13:44 -0700, Jerry Chu <[email-masked]> wrote:

> On Tue, Aug 24, 2010 at 9:28 AM, Hagen Paul Pfeifer <[email-masked]>

wrote:

> So it looks like the user timeout can be used in either senario

(shortening

> or lengthening) and in both cases is a lower bound, i.e., the connection

> should abort at or shortly after the specified user timeout.

> In this case does it make sense to combine the two? Will your TCP_UTO

> patch be ready anytime soon?

> Again an alternative is to allow configuring tcp_retries2 and

TCP_RTO_MAX

> directly. I'm open to suggestion but we'd like to get something in

sooner.

Hello Chu! My Idea: you provide functionality to modify the user timeout.

The interface should be generic enough to allow small as well as large - up

to 22 days - values. This interface should be sufficient for you and later

for me. Afterwards I provide an patch which apply on your groundwork. My

patch handle TCP UTO specific functionality like TCP option protocol

handling functionality, socket option, permissions, lower- and upper

bounds, ...

Did you check interactions with other TCP timers like keep-alive timer? 

Today in the evening I will focus on TCP Quick ACK modifications. After

that I am in the Alps for vacation for 5 days. Later on I will work on the

patch (the patch is in a good state, modification and testing should

consume only 2 evenings - hopefully ;-).

Cherry, is this ok for you?

Hagen